"""Add news events

Revision ID: d529539703f6
Revises: c3818d6b449a
Create Date: 2024-10-09 13:21:21.125297

"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

import clowm.db.types

# revision identifiers, used by Alembic.
revision: str = "d529539703f6"
down_revision: str | None = "c3818d6b449a"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "news",
        sa.Column("news_id", clowm.db.types.SQLUUID(length=16), nullable=False),
        sa.Column("content", mysql.TEXT(), nullable=False),
        sa.Column("title", sa.String(length=256), nullable=False),
        sa.Column("important_till", mysql.INTEGER(unsigned=True), nullable=True),
        sa.Column("creator_id", clowm.db.types.SQLUUID(length=16), nullable=True),
        sa.Column("category", sa.Enum("workflow", "resource", "system", native_enum=True), nullable=False),
        sa.Column("created_at", mysql.INTEGER(unsigned=True), nullable=False),
        sa.Column("updated_at", mysql.INTEGER(unsigned=True), nullable=False),
        sa.ForeignKeyConstraint(["creator_id"], ["user.uid"], ondelete="SET NULL"),
        sa.PrimaryKeyConstraint("news_id"),
    )
    op.create_index(op.f("ix_news_news_id"), "news", ["news_id"], unique=True)

    op.add_column(
        "bucketpermission",
        sa.Column(
            "scopes",
            clowm.db.types.SQLIntFlag(flag_type=clowm.db.types.BucketPermissionScopesDB),
            nullable=False,
        ),
    )
    op.get_bind().execute(
        sa.sql.text(
            """
UPDATE bucketpermission SET scopes = CASE permissions
    WHEN 'READ' THEN 1
    WHEN 'WRITE' THEN 2
    WHEN 'READWRITE' THEN 3
    ELSE 0
END
"""
        )
    )
    op.drop_column(
        "bucketpermission",
        "permissions",
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "bucketpermission",
        sa.Column(
            "permissions",
            sa.Enum("READ", "WRITE", "READWRITE", native_enum=True),
            nullable=False,
        ),
    )
    op.get_bind().execute(
        sa.sql.text(
            """
 UPDATE bucketpermission SET permissions = CASE scopes
     WHEN 1 THEN 'READ'
     WHEN 2 THEN 'WRITE'
     WHEN 3 THEN 'READWRITE'
     ELSE 'READ'
 END
 """
        )
    )
    op.drop_column(
        "bucketpermission",
        "scopes",
    )
    op.drop_index(op.f("ix_news_news_id"), table_name="news")
    op.drop_table("news")
    # ### end Alembic commands ###
